/*
 *	Copyright: Torquil Gault (tag@scatha.apana.org.au), 1998+
 *
 */

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
import java.applet.*;

import com.sun.java.swing.*;

import rpcs.system.*;

public class RPCSApplet extends JApplet {

	public JTabbedPane tRPCSMaster;
	public RPCSMap pRPCSMap;
	public RPCSModifiers pRPCSModifiers;
	public RPCSAlert pRPCSAlert;
	public RPCSSystem pRPCSSystem;
	public RPCSList lRPCSPlayer;
	public RPCSList lRPCSMonster;
	public RPCSList lRPCSTrap;
	public RPCSParam Params;

	public Font font8Pt, font10Pt, font12Pt;
	public Font font10PtBold, font12PtBold;
	public RPCSToolBar RPCSTBar;
	public RPCSMainMenu RPCSMenuBar;
	public URL RPCSCodeBase;
	public JPanel LeftPanel;
	public RPCSCopyright RPCSCRight;

	public RPCSGroup RPCSGrp;
	public RPCSGroupAction RPCSGrpAction;
	public RPCSAction RPCSActionScrn;
	public RPCSInitiative RPCSInitiativeScrn;

	public RPCSHerb pHerb;
	public RPCSEquipment pEquipment;

	public Vector     vRPCSPlayer;
	public Vector     vRPCSMonster;
	public Vector     vRPCSTrap;

	public Vector     vRPCSGroups;

      	public Frame RPCSParent;

	public Icon[] baseIcon;

	public String Browser, OS;

	public RPCSApplet() {
	}

	public void start() {
//		super.start();
//		RPCSCRight.setVisible(true);
		RPCSCRight.setAbout();
	}

	public void init() {
		RPCSParent = getFrame();
		setScreenPosition();

		Browser = System.getProperty("browser");
		OS = System.getProperty("os.name");
		System.out.println("Running in: " + Browser + "(" + OS + ")");

		if (Browser != null && Browser.indexOf("Netscape") != -1) {
		   try {
			netscape.security.PrivilegeManager.enablePrivilege("UniversalConnect");
		   } catch (Exception e) { System.out.println(e); }
		}

		try {
//	    	   UIManager.setLookAndFeel("com.sun.java.swing.windows.WindowsLookAndFeel");
//	    	   UIManager.setLookAndFeel("com.sun.java.swing.mac.MacLookAndFeel");
//	    	   UIManager.setLookAndFeel("com.sun.java.swing.motif.MotifLookAndFeel");
//	    	   com.sun.java.swing.jlf.JLFLookAndFeel.setCurrentTheme( new com.sun.java.swing.jlf.JLFDefaultTheme());
//	    	   UIManager.setLookAndFeel("com.sun.java.swing.jlf.JLFLookAndFeel");
//	    	   com.sun.java.swing.jlf.JLFLookAndFeel.setCurrentTheme( new com.sun.java.swing.jlf.JLFGrayTheme());
//	    	   UIManager.setLookAndFeel("com.sun.java.swing.jlf.JLFLookAndFeel");

		} catch (Exception e) { 
		   System.out.println(e);
//		   try {
//	    	     com.sun.java.swing.jlf.JLFLookAndFeel.setCurrentTheme( new com.sun.java.swing.jlf.JLFGrayTheme());
//	    	     UIManager.setLookAndFeel("com.sun.java.swing.jlf.JLFLookAndFeel");
//		   } catch (Exception e1) {;}
		}
//		SwingUtilities.updateComponentTreeUI(getRootComponent());

		try {
			RPCSCodeBase = getCodeBase();
		} catch (Exception e) {
		    try {
			RPCSCodeBase = new URL("file", "", "C:/Gaultt/Apps/RPCS/");
		    } catch (Exception ex) { ; }
		}

		vRPCSPlayer = new Vector();
		vRPCSMonster = new Vector();
		vRPCSTrap = new Vector();

		Params = new RPCSParam();
		Params.aRPCSMain = this;

		getContentPane().setLayout(new BorderLayout());
		setBackground(Color.lightGray);
		setSize(800,600);
		font8Pt = new Font("Dialog", Font.PLAIN, 8);
		font10Pt = new Font("Dialog", Font.PLAIN, 10);
		font12Pt = new Font("Dialog", Font.PLAIN, 12);
		font10PtBold = new Font("Dialog", Font.BOLD, 10);
		font12PtBold = new Font("Dialog", Font.BOLD, 12);

		RPCSMenuBar = new RPCSMainMenu();
		RPCSMenuBar.setParam(Params);
		setJMenuBar(RPCSMenuBar);

		RPCSTBar = new RPCSToolBar(RPCSCodeBase);
		RPCSTBar.setParam(Params);
		getContentPane().add(RPCSTBar, "North");

		tRPCSMaster = new JTabbedPane();
		tRPCSMaster.setFont(font12Pt);
		tRPCSMaster.setForeground(Color.black);
		tRPCSMaster.setBackground(Color.lightGray);
		tRPCSMaster.addComponentListener(new ComponentAdapter() {
		    public void componentResized(ComponentEvent e) {
			Dimension size = tRPCSMaster.getSize();
// System.out.println("ReSize: " + e.paramString() + " -> " + size.height);
			lRPCSPlayer.setPreferredSize(new Dimension(99,(int )(size.height*0.68)));
			lRPCSTrap.setPreferredSize(new Dimension(99,(int )(size.height*0.25)));
			lRPCSMonster.setPreferredSize(new Dimension(99,(int )(size.height*0.93)));
			lRPCSPlayer.repaint();
			lRPCSTrap.repaint();
			validate();
		    }
		});
		getContentPane().add(tRPCSMaster, "Center");

		pRPCSMap = new RPCSMap(Params);
		pRPCSMap.setGridType(RPCSMapArea.MAP_HEX);
//		pRPCSMap.setGridType(RPCSMapArea.MAP_SQUARE);
		tRPCSMaster.add(pRPCSMap);

		baseIcon = new Icon[3];
		baseIcon[0] = loadImageIcon("rpcs/images/Player/RPCSImage1.gif", "");
		baseIcon[1] = loadImageIcon("rpcs/images/Monster/RPCSImage1.gif", "");
		baseIcon[2] = loadImageIcon("rpcs/images/Trap/RPCSImage1.gif", "");
		pRPCSModifiers = new RPCSModifiers(Params);
		pRPCSModifiers.setBackground(Color.lightGray);
		tRPCSMaster.add(pRPCSModifiers);

		pRPCSAlert = new RPCSAlert(Params);
		pRPCSAlert.setBackground(Color.lightGray);
		tRPCSMaster.add(pRPCSAlert);

		pRPCSSystem = new RPCSSystem(Params);
		pRPCSSystem.setBackground(Color.lightGray);
		tRPCSMaster.add(pRPCSSystem);

		LeftPanel = new JPanel();
		LeftPanel.setLayout(new BorderLayout());
		getContentPane().add(LeftPanel, "West");

		lRPCSPlayer = new RPCSList(Params, "RPCSPlayer");
		lRPCSPlayer.setPreferredSize(new Dimension(99,349));
		lRPCSPlayer.setFont(font12Pt);
//		lRPCSPlayer.setForeground(Color.black);
//		lRPCSPlayer.setBackground(Color.white);
		lRPCSPlayer.setBackground(Color.lightGray);
		lRPCSPlayer.setToolTipText("Lists all the Players");
		LeftPanel.add(lRPCSPlayer, "North");

		lRPCSTrap = new RPCSList(Params, "RPCSTrap");
		lRPCSTrap.setPreferredSize(new Dimension(99,149));
		lRPCSTrap.setFont(font12Pt);
//		lRPCSTrap.setForeground(Color.black);
//		lRPCSTrap.setBackground(Color.white);
		lRPCSTrap.setBackground(Color.lightGray);
		lRPCSTrap.setToolTipText("Lists all the Traps");
		LeftPanel.add(lRPCSTrap, "Center");

		lRPCSMonster = new RPCSList(Params, "RPCSMonster");
		lRPCSMonster.setPreferredSize(new Dimension(99,499));
		lRPCSMonster.setFont(font12Pt);
//		lRPCSMonster.setForeground(Color.black);
//		lRPCSMonster.setBackground(Color.white);
		lRPCSMonster.setBackground(Color.lightGray);
		lRPCSMonster.setToolTipText("Lists all the Monsters");
		getContentPane().add(lRPCSMonster, "East");
		
		tRPCSMaster.addTab("  Combat Map  ", pRPCSMap);
		tRPCSMaster.addTab("  Modifiers  ", pRPCSModifiers);
		tRPCSMaster.addTab("  Alerts  ", pRPCSAlert);
		tRPCSMaster.addTab("  System  ", pRPCSSystem);
		tRPCSMaster.setSelectedIndex(0);

		RPCSCRight = new RPCSCopyright(RPCSParent, "RPCS Copyright Message", true);
		RPCSCRight.Init(RPCSCodeBase, "rpcs/images/RPCSMain.gif", 
			"(C) Torquil Gault");
		RPCSCRight.setLocation(200, 80);

		RPCSGrp = new RPCSGroup(Params);
		RPCSGrpAction = new RPCSGroupAction(Params);
		RPCSActionScrn = new RPCSAction(Params);
		RPCSInitiativeScrn = new RPCSInitiative(Params);
		pHerb = new RPCSHerb(Params);
		pEquipment = new RPCSEquipment(Params);
/*
	RPCSPlayer Player = new RPCSPlayer(RPCSParent, Params, baseIcon[0]);
	Player.setName("Qot L'Tar"); Player.setHits(76, 134); Player.setLocation(100, 90);
	Player = new RPCSPlayer(RPCSParent, Params, baseIcon[0]);
	Player.setName("Selka Tamar"); Player.setHits(26, 34); Player.setLocation(150, 140);
	Player.updateDetails(true);

	RPCSMonster Monster = new RPCSMonster(RPCSParent, Params, baseIcon[1]);
	Monster.setName("Dragoth"); Monster.setHits(126, 134);Monster.setLocation(200, 200);
	Monster.updateDetails(true);

	RPCSTrap Trap = new RPCSTrap(RPCSParent, Params, baseIcon[2]);
	Trap.setName("Bad Trap"); Trap.setHits(29, 34);Trap.setLocation(250, 290);
	Trap.updateDetails(true);
*/
		validate();
	}

	public ImageIcon loadImageIcon(String filename, String description) {
	   URL url;

		if (RPCSCodeBase.getHost() == null)
		   return new ImageIcon(filename, description);
		try {
		   url = new URL(RPCSCodeBase, filename);
		} catch(MalformedURLException e) {
			System.out.println("Error in : loadImageIcon");
			return null;
		}
		return new ImageIcon(url, description);
	}

	public Frame getFrame() {
      	   Container parent = this;
      		for (; parent != null && !(parent instanceof Frame);
			parent = parent.getParent());
      		if (parent != null)
			return (Frame)parent;
      		else
			return null;
	}

	public void setScreenPosition() {
       	   Dimension dim = getToolkit().getScreenSize();
           Rectangle abounds = getBounds();
       	   Dimension dd = getSize();

        	RPCSParent.setLocation((dim.width - abounds.width) / 2,
        	     (dim.height - abounds.height) / 2);
    		requestFocus();
	}

	public void setCenter(Component parent, Component child) {
		Dimension pdim = parent.getSize();
		Point ppt = parent.getLocationOnScreen();
		Dimension cdim = child.getSize();
		child.setLocation(ppt.x + (pdim.width - cdim.width)/2,
			ppt.y + (pdim.height - cdim.height)/2);
	}

	public static void main(String args[]) {

		JFrame fRpcs = new JFrame("RPCS - The RolePlaying Combat System");
		fRpcs.addWindowListener(new WindowAdapter() {
		   public void windowClosing(WindowEvent e) {
			System.exit(0); 
		   }
		});

		RPCSApplet aRpcs = new RPCSApplet();
		fRpcs.getContentPane().add(aRpcs);
		fRpcs.setSize(800,600);
		fRpcs.show();

		aRpcs.init();
		aRpcs.start();
	}
}
