/*
 *	Copyright: Torquil Gault (tag@scatha.apana.org.au), 1998+
 *
 */

package rpcs.system;

import com.sun.java.swing.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import rpcs.system.*;

public class RPCSBaseModifiers extends JPanel implements Serializable {
	RPCSTable MTable;
	RPCSParam Params;
	JComboBox MType, MEffects;

	public RPCSBaseModifiers(RPCSParam params) {
		super();
		Params = params;

		init();
	}

	public void init() {
		MType = new JComboBox(new String[] {"Attack", "Defence", "Health", "Damage", "Save", "Move", "All", "All (ADS)", "All (AD)", "All (DS)"});
		MType.setEditable(false);

		MEffects = new JComboBox(new String[] {"All Players", "All Monsters", "All Traps", "Everything", "Group1", "Group2", "Qot L'Tar", "Selka Tamar"});
		MEffects.setEditable(false);

		MTable = new RPCSTable(4,23);
		MTable.setColumnHeaders(new String[] {"# Rnds", "Type", "Bonus", "Whom it Effects"});
		MTable.setColumnWidths(new int[] {50, 65, 50, 800});
		add(MTable);
		MTable.setColumnType(1, MType);
		MTable.setColumnType(3, MEffects);
	}
}

class RPCSMod_Tbl implements Serializable {
	int     mo_rnd;		/* no rnds lasts */
	int     mo_bonus;	/* bonus */
	String  mo_type;	/* type A,D,M,R */
	Vector  mo_effects;	/* who it effects, their ID's */

	public RPCSMod_Tbl() {
	}
}
