/*
 *	Copyright: Torquil Gault (tag@scatha.apana.org.au), 1998+
 *
 */

package rpcs.system;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import rpcs.event.*;

public class RPCSBaseObject implements Serializable {
	String	name;		/* name */
	int     level;		/* Character Level */
	String	ctype;		/* type - fighter/mage etc */
	String	realm;		/* magic realm */
	String	armor;		/* armor type */
	String	armor_rating;	/* armor rating */
	String 	no_atks;	/* No. attacks they give */

	Vector  weapons;	/* their weapons 0-2=melee, 3=miss, 4=thrown,
				   5=spell */

	String	size;		/* their size SMLH */
	int     cur_ob;		/* current OB with attacking weapon */
	int     add_ob; 	/* additives to current OB */
	int     cur_db; 	/* current DB */
	int     base_db;	/* base DB */
	int     shld_db; 	/* Shield DB */
	int     spc_db; 	/* special additional DB */
	String	leg_armor;	/* Has Leg greaves ? */
	String	arm_armor;	/* Has Arm greaves ? */
	String	helm_armor;	/* Has Helm ? */
	int	move_rate;	/* Base Movement rate */

	int     max_hits;	/* max Hits */
	int     cur_hits; 	/* current Hits */

	int	status;		/* -1 = Dead, 0 = Inactive/Uncon, 1 = OK */

	int    	bleed;  	/* current Bleding Rate */
	String	wounds;		/* various bleeding wounds */
	int     stun;		/* no RNDs stunned */
	int    	rnd_parry;	/* rnds must parry */
	int    	rnd_nparry;	/* rnds must no parry */
	int    	rnd_death;	/* rnds to death */
	int    	rnd_inact;	/* rnds inactive */
	int[][] tmp_pen;	/* temp penalties ie. 8 hits 3 rnds. 0=Type,
				   1=value, 2=no_rnds */

	int     no_defd;	/* no of attacks to be defended against */

	int    	no_actns;	/* no of actions performed this round */
	int    	cur_actn;	/* current action (pointer) being performed */
	boolean	do_oppact;	/* currently doing an opportunity action */

	int     cur_weap;	/* current weapon, pointer into weap[] */
	int	delay_atk;	/* an auto attack next round, int o weap[] */
	String	tmp1;		/* some temp variables */
	int    	tmp2;		/* some temp variables */
	int    	parry;		/* their parry amount */

	boolean hit_thisrnd;	/* Have they been hit this round ? */

	Vector	action;		/* actions they're doing */

	RPCSParam Params;	/* */

	public JDialog  ObjDialog;	/* the Window to display info in */
	public JTabbedPane TabPanel;	/* all the tabs */
	public JPanel[] ObjPanel;	/* all the panels */
	public RPCSForm[] fPanel;
	public RPCSWeapon Weapon;

	public int Direction;	/* Facing which way ?? */

	final int FACING_N = 0;
	final int FACING_NE = 4;
	final int FACING_NW = 5;
	final int FACING_S = 1;
	final int FACING_SE = 7;
	final int FACING_SW = 8;
	final int FACING_E = 2;
	final int FACING_W = 3;

	public int[] FacingAngle = {0, 180, 90, 270, 45, 315, 135, 225};

	final int PANEL_PLYR = 0; /* panel with all the basic dets */
	final int PANEL_EXTA = 1; /* panel has all the extra dets */
	final int PANEL_WEAP = 2; /* panel has all the weapon dets */
	final int PANEL_ACTS = 3; /* panel has all the action dets */
	final int PANEL_BUTT = 4; /* panel has all the buttons */

	public RPCSButton ObjButton;	/* the button for this Object */

	JButton[] tButton;

	public RPCSBaseObject(Frame pFrame, RPCSParam param) {
		Params = param;

		init(pFrame);
	}

	public RPCSBaseObject(Frame pFrame, RPCSParam param, Icon icon) {
		Params = param;

		init(pFrame);
		ObjButton.setIcon(icon);
	}

	public void init(Frame pFrame) {
		name = new String();
		ctype = new String();
		realm = new String();
		armor = new String();
		armor_rating = new String();
		size = new String();
		no_atks = new String("1");
		leg_armor = new String();
		arm_armor = new String();
		helm_armor = new String();
		wounds = new String();
		tmp1 = new String();
		tmp_pen = new int[8][3];
		level = 1;

		ObjDialog = new JDialog(pFrame, "RPCS Object Window");
		ObjDialog.getContentPane().setLayout(new BorderLayout());
		ObjDialog.setSize(500, 350);
		ObjDialog.setModal(true);
		TabPanel = new JTabbedPane();
		ObjDialog.getContentPane().add(TabPanel);
		Params.aRPCSMain.setCenter(pFrame, ObjDialog);

		ObjPanel = new JPanel[5];
		ObjPanel[0] = new JPanel();
		ObjPanel[1] = new JPanel();
		ObjPanel[2] = new JPanel(); // ObjPanel[2].setLayout(new BorderLayout());
		ObjPanel[3] = new JPanel();
		ObjPanel[4] = new JPanel();

		fPanel = new RPCSForm[4];
		fPanel[PANEL_PLYR] = new RPCSForm(ObjPanel[PANEL_PLYR], false);
		fPanel[PANEL_EXTA] = new RPCSForm(ObjPanel[PANEL_EXTA], false);
//		fPanel[PANEL_WEAP] = new RPCSForm(ObjPanel[PANEL_WEAP], false);
		fPanel[PANEL_ACTS] = new RPCSForm(ObjPanel[PANEL_ACTS], false);

		ObjDialog.getContentPane().add(ObjPanel[PANEL_BUTT], "South");
		ObjPanel[PANEL_BUTT].setBackground(Color.white);
		tButton = new JButton[3];
		tButton[0] = new JButton("  OK  ");
		tButton[1] = new JButton("  Cancel  ");
		tButton[2] = new JButton("  Reset  ");
		ObjPanel[PANEL_BUTT].add(tButton[0], "East");
		ObjPanel[PANEL_BUTT].add(tButton[1], "Center");
		ObjPanel[PANEL_BUTT].add(tButton[2], "West");

		TabPanel.addTab("  Basic Details  ", ObjPanel[PANEL_PLYR]);
		TabPanel.addTab("  Extra Details  ", ObjPanel[PANEL_EXTA]);
		TabPanel.addTab("  Weapon Details  ", ObjPanel[PANEL_WEAP]);
		TabPanel.addTab("  Action Details  ", ObjPanel[PANEL_ACTS]);

		ObjDialog.addWindowListener(new WindowAdapter() {
		   public void windowClosing(WindowEvent e) { 
			setVisible(false); 
		   }
		});

		ObjButton = new RPCSButton("");
		ObjButton.setObject(this);

		tButton[0].addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				updatePlayerDetails();
				doOK();
			}
		});
		tButton[1].addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doCancel();
			}
		});
		tButton[2].addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doReset();
			}
		});

		Weapon = new RPCSWeapon(ObjPanel[PANEL_WEAP]);

		Params.aRPCSMain.pRPCSMap.addToMap(ObjButton, 100, 100);
	}

	public void initVars() {
		Direction = FACING_N;
		status = 1;
// Column 1
		fPanel[PANEL_PLYR].add("Name:", name, 9);
		{
		  String[] ts1 = {"Fighter", "Priest", "Thief", "Mage"};
		  fPanel[PANEL_PLYR].add("Type:", ts1, "Fighter");
		}
		fPanel[PANEL_PLYR].newBlankRow("Type:");
		fPanel[PANEL_PLYR].add("Level:", level);
		fPanel[PANEL_PLYR].newBlankRow("Level:");
		fPanel[PANEL_PLYR].add("# Attacks:", no_atks, 2);
		fPanel[PANEL_PLYR].add("Move Rate:", move_rate);
		fPanel[PANEL_PLYR].newBlankRow("Move Rate:");
		{
		  String[] ts = {"None", "Soft Lthr", "Hard Lthr", "Chain",
				 "Plate"};
		  fPanel[PANEL_PLYR].add("Armor: Type:", ts, "None");
		}
		fPanel[PANEL_PLYR].newBlankRow("Armor: Type:");
		{
		  String[] ts = {"None", "Leather", "Metal"};
		  fPanel[PANEL_PLYR].add("Armor: Leg:", ts, "None");
		}
		{
		  String[] ts = {"None", "Leather", "Metal"};
		  fPanel[PANEL_PLYR].add("Helm:", ts, "None");
		}
// Column 2
		fPanel[PANEL_PLYR].newColumn("Name:");
		fPanel[PANEL_PLYR].add("Realm:", realm);
		{
		  String[] ts = {"Small", "Medium", "Large", "Huge"};
		  fPanel[PANEL_PLYR].add("Size:", ts, "Medium");
		}
		fPanel[PANEL_PLYR].newColumnRow("Realm:", "# Attacks:", "Max Hits:", max_hits);
		fPanel[PANEL_PLYR].add("Cur Hits:", cur_hits);
		{
		  String[] ts = {"AC-10", "AC-9","AC-8","AC-7","AC-6","AC-5","AC-4","AC-3","AC-2","AC-1","AC0","AC1", 
				 "AC2","AC3","AC4","AC5","AC6","AC7","AC8","AC9", "AC10"};
		  fPanel[PANEL_PLYR].newColumnRow("Realm:", "Armor: Type:", "Rating:", ts, "AC1");
		}
		fPanel[PANEL_PLYR].newBlankRow("Rating:");
		{
		  String[] ts = {"None", "Leather", "Metal"};
		  fPanel[PANEL_PLYR].add("Arm:", ts, "None");
		}

// Column 1
		fPanel[PANEL_EXTA].add("Bleeding:", bleed);
		fPanel[PANEL_EXTA].newBlankRow("Bleeding:");
		fPanel[PANEL_EXTA].add("Round: Parry:", rnd_parry);
		fPanel[PANEL_EXTA].add("Death:", rnd_death);
// Column 2
		fPanel[PANEL_EXTA].newColumn("Bleeding:");
		fPanel[PANEL_EXTA].add("Wounds:", wounds);
		fPanel[PANEL_EXTA].newBlankRow("Wounds:");
		fPanel[PANEL_EXTA].add("No Parry:", rnd_nparry);
		fPanel[PANEL_EXTA].add("Stun:", stun);
// Column 3
		fPanel[PANEL_EXTA].newColumn("No Parry:");
		fPanel[PANEL_EXTA].add("Inaction:", rnd_inact);

// Column 1
		fPanel[PANEL_ACTS].add("Cur OB:", cur_ob);
		fPanel[PANEL_ACTS].add("Base DB:", base_db);
		fPanel[PANEL_ACTS].add("No Defd:", no_defd);
		fPanel[PANEL_ACTS].add("Cur Weap:", cur_weap);
		fPanel[PANEL_ACTS].add("Do OppAct:", do_oppact);
// Column 2
		fPanel[PANEL_ACTS].newColumn("Cur OB:");
		fPanel[PANEL_ACTS].add("Delay Atk:", delay_atk);
		fPanel[PANEL_ACTS].add("Add OB:", add_ob);
		fPanel[PANEL_ACTS].add("Shld DB:", shld_db);
		fPanel[PANEL_ACTS].add("No Actns:", no_actns);
// Column 3
		fPanel[PANEL_ACTS].newColumn("Delay Atk:");
		fPanel[PANEL_ACTS].add("Cur Actn:", cur_actn);
		fPanel[PANEL_ACTS].add("Cur DB:", cur_db);
		fPanel[PANEL_ACTS].add("Spec DB:", spc_db);
		fPanel[PANEL_ACTS].add("Parry:", parry);
	}

	public void setIcon(String iconfile) {
	}

	public void setIcon(Icon icon) {
	}

	public String toString() {
		return name;
	}

	public void setVisible(boolean b) {
		Params.aRPCSMain.setCenter(Params.aRPCSMain.RPCSParent, ObjDialog);
		ObjDialog.setVisible(b);
		TabPanel.setSelectedIndex(0);
	}

	public void doOK() {
		ObjDialog.setVisible(false);
		TabPanel.setSelectedIndex(0);
	}

	public void doCancel() {
		ObjDialog.setVisible(false);
		TabPanel.setSelectedIndex(0);
	}

	public void doReset() {
		ObjDialog.setVisible(false);
	}

	public void updateDetails(boolean action) {
		ObjButton.setText(name);
		if (max_hits != 0)
		   ObjButton.setToolTipText(name + " " + (cur_hits*100)/max_hits + "%");
		else
		   ObjButton.setToolTipText(name);

		if (action)
		   this.updateForm();
	}

	public void updateForm() {
		fPanel[PANEL_PLYR].setValue("Name:", name);
		fPanel[PANEL_PLYR].setValue("Level:", level);
		fPanel[PANEL_PLYR].setValue("Max Hits:", max_hits);
		fPanel[PANEL_PLYR].setValue("Cur Hits:", cur_hits);
		fPanel[PANEL_PLYR].setValue("Type:", ctype);
		fPanel[PANEL_PLYR].setValue("Realm:", realm);
		fPanel[PANEL_PLYR].setValue("Armor: Type:", armor);
		fPanel[PANEL_PLYR].setValue("Rating:", armor_rating);
		fPanel[PANEL_PLYR].setValue("Size:", size);
		fPanel[PANEL_PLYR].setValue("# Attacks:", no_atks);
		fPanel[PANEL_PLYR].setValue("Armor: Leg:", leg_armor);
		fPanel[PANEL_PLYR].setValue("Arm:", arm_armor);
		fPanel[PANEL_PLYR].setValue("Helm:", helm_armor);
		fPanel[PANEL_PLYR].setValue("Move Rate:", move_rate);
		fPanel[PANEL_EXTA].setValue("Bleeding:", bleed);
		fPanel[PANEL_EXTA].setValue("Wounds:", wounds);
		fPanel[PANEL_EXTA].setValue("Stun:", stun);
		fPanel[PANEL_EXTA].setValue("Round: Parry:", rnd_parry);
		fPanel[PANEL_EXTA].setValue("No Parry:", rnd_nparry);
		fPanel[PANEL_EXTA].setValue("Death:", rnd_death);
		fPanel[PANEL_EXTA].setValue("Inaction:", rnd_inact);
		fPanel[PANEL_ACTS].setValue("Cur OB:", cur_ob);
		fPanel[PANEL_ACTS].setValue("Add OB:", add_ob);
		fPanel[PANEL_ACTS].setValue("Cur DB:", cur_db);
		fPanel[PANEL_ACTS].setValue("Base DB:", base_db);
		fPanel[PANEL_ACTS].setValue("Shld DB:", shld_db);
		fPanel[PANEL_ACTS].setValue("Spec DB:", spc_db);
		fPanel[PANEL_ACTS].setValue("No Defd:", no_defd);
		fPanel[PANEL_ACTS].setValue("No Actns:", no_actns);
		fPanel[PANEL_ACTS].setValue("Cur Actn:", cur_actn);
		fPanel[PANEL_ACTS].setValue("Do OppAct:", do_oppact);
		fPanel[PANEL_ACTS].setValue("Cur Weap:", cur_weap);
		fPanel[PANEL_ACTS].setValue("Delay Atk:", delay_atk);
		fPanel[PANEL_ACTS].setValue("Parry:", parry);
	}

	public void setName(String name) {
		this.name = name;
		this.updateDetails(true);
	}

	public void setHits(int h1, int h2) {
		this.cur_hits = h1;
		this.max_hits = h2;
		this.updateDetails(true);
	}

	public void setLocation(int x, int y) {
		ObjButton.setLocation(x, y);
	}

	public void updatePlayerDetails() {
	   name = fPanel[PANEL_PLYR].getFieldValue("Name:");
	   level = fPanel[PANEL_PLYR].getIntFieldValue("Level:");
	   ctype = fPanel[PANEL_PLYR].getFieldValue("Type:");
	   realm = fPanel[PANEL_PLYR].getFieldValue("Realm:");
	   armor = fPanel[PANEL_PLYR].getFieldValue("Armor: Type:");
	   no_atks = fPanel[PANEL_PLYR].getFieldValue("# Attacks:");
	   size = fPanel[PANEL_PLYR].getFieldValue("Size:");
	   leg_armor = fPanel[PANEL_PLYR].getFieldValue("Armor: Leg:");
	   arm_armor = fPanel[PANEL_PLYR].getFieldValue("Arm:");
	   helm_armor = fPanel[PANEL_PLYR].getFieldValue("Helm:");
	   move_rate = fPanel[PANEL_PLYR].getIntFieldValue("Move Rate:");
	   max_hits = fPanel[PANEL_PLYR].getIntFieldValue("Max Hits:");
	   cur_hits = fPanel[PANEL_PLYR].getIntFieldValue("Cur Hits:");
	   bleed = fPanel[PANEL_EXTA].getIntFieldValue("Bleeding:");
	   wounds = fPanel[PANEL_EXTA].getFieldValue("Wounds:");
	   stun = fPanel[PANEL_EXTA].getIntFieldValue("Stun:");

	   rnd_parry = fPanel[PANEL_EXTA].getIntFieldValue("Round: Parry:");
	   rnd_nparry = fPanel[PANEL_EXTA].getIntFieldValue("No Parry:");
	   rnd_death = fPanel[PANEL_EXTA].getIntFieldValue("Death:");
	   rnd_inact = fPanel[PANEL_EXTA].getIntFieldValue("Inaction:");

	   cur_ob = fPanel[PANEL_ACTS].getIntFieldValue("Cur OB:");
	   add_ob = fPanel[PANEL_ACTS].getIntFieldValue("Add OB:");
	   cur_db = fPanel[PANEL_ACTS].getIntFieldValue("Cur DB:");
	   base_db = fPanel[PANEL_ACTS].getIntFieldValue("Base DB:");
	   shld_db = fPanel[PANEL_ACTS].getIntFieldValue("Shld DB:");
	   spc_db = fPanel[PANEL_ACTS].getIntFieldValue("Spec DB:");
	   no_defd = fPanel[PANEL_ACTS].getIntFieldValue("No Defd:");
	   no_actns = fPanel[PANEL_ACTS].getIntFieldValue("No Actns:");
	   cur_actn = fPanel[PANEL_ACTS].getIntFieldValue("Cur Actn:");
	   do_oppact = fPanel[PANEL_ACTS].getBooleanFieldValue("Do OppAct:");
	   cur_weap = fPanel[PANEL_ACTS].getIntFieldValue("Cur Weap:");
	   delay_atk = fPanel[PANEL_ACTS].getIntFieldValue("Delay Atk:");
	   parry = fPanel[PANEL_ACTS].getIntFieldValue("Parry:");

	   this.updateDetails(false);
	}

	public void setBackground(Color col) {
	   ObjButton.setBackground(col);
	}

	public void setActionStatus(int status) {
	}
}
