
/*
 *	Copyright: Torquil Gault (tag@scatha.apana.org.au), 1998+
 *
 */

package rpcs.system;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import rpcs.system.*;

public class RPCSList extends JPanel implements Serializable {
	Vector vObjects;
	Vector vList;
	JScrollPane ScrollPanel;
	JList List;
	RPCSListPMenu PMenu;
	RPCSParam Params;
	String sObj;

	public RPCSList(RPCSParam param, String obj) {
		super();
		List = new JList();
		List.setBackground(Color.white);
		sObj = obj;
		Params = param;
		Init();
	}

	public void Init() {
		ScrollPanel = new JScrollPane();
		ScrollPanel.getViewport().setView(List);
		add(ScrollPanel);

		vObjects = new Vector();
		vList = new Vector();

		PMenu = new RPCSListPMenu(Params, sObj);

		List.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
			   int idx = List.locationToIndex(e.getPoint());
				if (e.getClickCount() == 2) {
// System.out.println("Dbl Click on: " + idx);
				   if (idx == -1)
					return;
				   Object obj = vObjects.elementAt(idx);
				   if (obj instanceof RPCSPlayer)
					((RPCSPlayer )obj).setVisible(true);
				   else if (obj instanceof RPCSMonster)
					((RPCSMonster )obj).setVisible(true);
				   else if (obj instanceof RPCSTrap)
					((RPCSTrap )obj).setVisible(true);
				}
				else {
				   if (e.isMetaDown()) {
// System.out.println("RMB Click on: " + idx);
				   	if (idx == -1) {
					   PMenu.show(List, e.getX(), e.getY());
					   return;
					}
					Object obj = vObjects.elementAt(idx);
					PMenu.setObject(obj);
					PMenu.show(List, e.getX(), e.getY());
				   }
				   else if (e.isShiftDown()) {
// System.out.println("CMB Click on: " + idx);
				   }
				}
			}
		});
	}

	public void setPreferredSize(Dimension dim) {
		super.setPreferredSize(dim);
		ScrollPanel.setPreferredSize(dim);
	}

	public void setToolTipText(String text) {
		List.setToolTipText(text);
	}

	public void addToList(Object obj) {
		vObjects.addElement(obj);
		vList.addElement(obj.toString());
		List.setListData(vList);
	}

	public void updateDetails(Object obj) {
		int idx = vObjects.indexOf(obj);
		if (idx == -1)
		   return;
		vList.setElementAt(obj.toString(), idx);
	}
}
