/*
 *	Copyright: Torquil Gault (tag@scatha.apana.org.au), 1998+
 *
 */

package rpcs.system;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import rpcs.system.*;

public class RPCSButton extends JButton {
	protected RPCSBaseObject BaseObj;
	protected RPCSButtonPMenu PMenu;
	protected RPCSButton tButton;
	protected Icon icon;
	protected Point bLoc;
	protected int cX, cY;
	protected Dimension pSize;
	protected Dimension cSize;
	protected boolean BeingDragged = false;

	public int GridX, GridY;

	public RPCSButton(Icon icon) {
		super(icon);
		this.icon = icon;
		init();
	}

	public RPCSButton(String title) {
		super(title);
		init();
	}

	public RPCSButton(String title, Icon icon) {
		super(title, icon);
		this.icon = icon;
		init();
	}

	public void init() {
		setFont(new Font("Dialog", Font.PLAIN, 10));
		setMargin(new Insets(0,0,0,0));

		setHorizontalTextPosition(JButton.CENTER);
		setVerticalTextPosition(JButton.BOTTOM);

		PMenu = new RPCSButtonPMenu();

		tButton = this;

		GridX = GridY = -1;

		addMouseMotionListener(new MouseMotionAdapter() {
			public void mouseDragged(MouseEvent e) {
			    if (e.getModifiers() == 0) {
// System.out.println("B In Dragged: " + e.paramString());
				bLoc = getLocation();
				bLoc.x += e.getX() + cX;
				bLoc.y += e.getY() + cY;
				if (bLoc.x > pSize.width)
				   bLoc.x = pSize.width;
				if (bLoc.x < 0)
				   bLoc.x = 1;
				if (bLoc.y > pSize.height)
				   bLoc.y = pSize.height;
				if (bLoc.y < 0)
				   bLoc.y = 1;
// System.out.println("B In Dragged: X = " + bLoc.x + " Y = " + bLoc.y);
				setLocation(bLoc);
				BeingDragged = true;
			    }
			}
		});

		addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				cX = - e.getX();
				cY = - e.getY();
				cSize = e.getComponent().getSize();
				pSize = e.getComponent().getParent().getSize();
// System.out.println("pSize = (" + pSize.width + ", " + pSize.height + ")");
				pSize.width -= cSize.width;
				pSize.height -= cSize.height;
				BeingDragged = false;
			}

			public void mouseClicked(MouseEvent e) {
// System.out.println("B In Click: " + e.paramString());
				if (e.getClickCount() == 2) {
// System.out.println("B Dbl Click on: ");
				   if (BaseObj != null) {
					BaseObj.setVisible(true);
				   }
				}
				else {
				   if (e.isMetaDown()) {
// System.out.println("B RMB Click on: ");
					PMenu.show(tButton, e.getX(), e.getY());
				   }
				   else if (e.isShiftDown()) {
// System.out.println("B CMB Click on: ");
				   }
				}
			}

			public void mouseReleased(MouseEvent e) {
			   if (BeingDragged && BaseObj != null) {
				GridX = GridY = -1;
				BaseObj.Params.aRPCSMain.pRPCSMap.Map.convertToGrid(tButton);
			   }
			}
		});
	}
	
	public void setObject(RPCSBaseObject obj) {
		BaseObj = obj;
		PMenu.setObject(obj);
	}

	public RPCSBaseObject getObject() {
		return BaseObj;
	}

	public void setIcon(Icon icon) {
		super.setIcon(icon);
		this.icon = icon;
	}

	public void setGridLocation(int gx, int gy) {
		GridX = gx;
		GridY = gy;
	}

	public void setDirection() {
	   int x=0, y=0;

		if (BaseObj != null) {
		   switch (BaseObj.Direction) {
			case 0:
				break;
			case 1:
				break;
			case 2:
				break;
			case 3:
				break;
			case 4:
				break;
			case 5:
				break;
			case 6:
				break;
			case 7:
				break;
			case 8:
				break;
		   }
		}
	}
}
